
#include "presto.h"
#include "alarm.h"
#include <stream.h>
#include <signal.h>
#include <osfcn.h>

int tester1()
{
  Alarm *alarm = new Alarm;

//  alarm->Init();

  for( int j = 0; j < 10; j++ ) {
    dout << "########## tester(1) \n";
    alarm->WakeMeUpAfter( 0.1 );
  }

  dout << "TESTER(1) THREAD TERMINATING\n";
  return 0;
}

int tester2()
{
  Alarm *alarm = new Alarm;

//  alarm->Init();

  for( int j = 0; j < 10; j++ ) {
    dout << "########## tester(2) \n";
    alarm->WakeMeUpAfter( 0.1 );
  }

  dout << "TESTER(2) THREAD TERMINATING\n";
  return 0;
}


Main::init()
{
	numprocessors = 1;
	quantum = 0;

	for (argc--, argv++; *argv && **argv == '-'; argv++, argc--)
		switch (*(*argv + 1)) {
			case 'q':
				quantum = atoi(*argv + 2);
				break;
			case 'n':
				numprocessors = atoi(*argv + 2);
				break;
			default:
				cerr << chr(*(*argv + 1)) << " unknown flag.\n";
		    		return -1;
		}
	return 0;
}


Main::main()
{
  Thread *t[2];

  t[0] = new Thread("ALARM_TESTER(1)");
  t[0]->start( (Objany) this, (PFany) tester1 );

  t[1] = new Thread("ALARM_TESTER(2)");
  t[1]->start( (Objany) this, (PFany) tester2 );

  for( int j = 0; j < 10; j++ ) {
    for( int i = 0; i < 100000; i++ );
    dout << "DING \n";
  }

  dout << "BYE! BYE!\n\n";
}
